'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''

from xml.dom.minidom import parse, parseString
import datetime
import time
import locale
import re
class XMLProcessor():
	def __init__(self):
		pass
	
	def get_statuses(self,text,is_direct=False):
		dom = parseString(text)
		if is_direct:
			tag='direct_message'
		else:
			tag='status'
		return_data = dom.getElementsByTagName(tag)
		del dom
		return return_data

	def get_dom(self,text):
		dom = parseString(text)
		return dom
	
	def get_user_info(self,text):
		dom = parseString(text)
		data = {}
		data['id'] = self.get_node_text(dom,'id')
		data['name'] = self.get_node_text(dom,'name')
		data['screen_name'] = self.get_node_text(dom,'screen_name')
		data['location'] = self.get_node_text(dom,'location')
		data['description'] = self.get_node_text(dom,'description')
		data['url']=self.get_node_text(dom,'url')
		data['following']=self.get_node_text(dom,'following')
		data['profile_image_url']=self.get_node_text(dom,'profile_image_url')
		return data
		
	def get_group_info(self,text):
		dom = parseString(text)
		data = {}
		data['id'] = self.get_node_text(dom,'id')
		data['fullname'] = self.get_node_text(dom,'fullname')
		data['location'] = self.get_node_text(dom,'location')
		data['description'] = self.get_node_text(dom,'description')
		data['stream_logo']=self.get_node_text(dom,'stream_logo')
		data['member']=self.get_node_text(dom,'member')
		#data['url']=self.get_node_text(dom,'url')
		data['homepage']=self.get_node_text(dom,'homepage')
		return data
	
	def get_user_is_friend(self,text):
		dom = parseString(text)
		f = self.get_node_text(dom,'friends')
		if f=="true":
			friends = True
		else:
			friends = False
		return friends
	
	def get_user_is_member(self,text):
		dom = parseString(text)
		m = self.get_node_text(dom,'is_member')
		if m=="true":
			member = True
		else:
			member = False
		return member
	
	
	def get_node_text(self,node,tag):
		try:
			text=node.getElementsByTagName(tag)[0].firstChild.data
		except:
			text=None
		return text

	def xmlentities(self,data):
		data = data.replace("&", "&amp;")
		data = data.replace("<", "&lt;")
		data = data.replace("\"", "&quot;")
		data = data.replace(">", "&gt;")
		return data

	def get_dent_data(self,status):
		#make dict to hold the data
		dict={}
		dict['status_id'] = int(self.get_node_text(status,"id") )
		dict['name'] = self.get_node_text(status,"name")
		dict['screen_name']=self.get_node_text(status,"screen_name")
		dict['text']=self.get_node_text(status,"text")
		dict['in_reply_to_screen_name']=self.get_node_text(status,"in_reply_to_screen_name")
		dict['profile_image_url']=self.get_node_text(status,"profile_image_url")
		dict['source']=self.get_node_text(status,"source")
		dict['favorited']=self.get_node_text(status,"favorited")
		#what server is this shit from?
		server = self.get_node_text(status,"statusnet:profile_url")

		# we should clean the source ( if there is one )
		if dict['source']!=None:
			dict['source']=re.sub(r'<[^>]*?>', '', dict['source'])
		created=self.get_node_text(status,'created_at')
		''' Wed May 26 01:27:08 +0000 2010 '''
		#get the current locale time formatting
		lctime = locale.getlocale(locale.LC_TIME)
		#set the locale to the generic C
		locale.setlocale(locale.LC_TIME,"C")
		ptime = time.strptime(created,'%a %b %d %H:%M:%S +0000 %Y')
		#reset to the current locale
		try:
			locale.setlocale(locale.LC_ALL,lctime)
		except:
			pass # this was an issue on the N810
		t = time.mktime( ptime )
		t-= ( time.timezone)
		lt = time.localtime(t)
		#what about DST?#fuck DST move to relative time
		#format the time		
		dict['time']=time.asctime(lt)
		#is this in reply to some shit?
		in_reply_to_id_str=self.get_node_text(status,'in_reply_to_status_id')
		if in_reply_to_id_str!=None:
				 in_reply_to_id=int(in_reply_to_id_str)
		else:
				 in_reply_to_id=None
		dict['in_reply_to_id']=in_reply_to_id
		return dict
